import { MissingAdapter, MissingAdapterMethods, MissingAPIRoute, MissingAuthorize, MissingSecret, InvalidCallbackUrl, InvalidEndpoints, UnsupportedStrategy } from "../errors";
import type { RequestInternal } from "..";
import type { WarningCode } from "../../utils/logger";
import type { AuthOptions } from "../types";
declare type ConfigError = MissingAdapter | MissingAdapterMethods | MissingAPIRoute | MissingAuthorize | MissingSecret | InvalidCallbackUrl | UnsupportedStrategy | InvalidEndpoints | UnsupportedStrategy;
/**
 * Verify that the user configured `next-auth` correctly.
 * Good place to mention deprecations as well.
 *
 * REVIEW: Make some of these and corresponding docs less Next.js specific?
 */
export declare function assertConfig(params: {
    options: AuthOptions;
    req: RequestInternal;
}): ConfigError | WarningCode[];
export {};
