"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = email;

var _web = require("../web");

async function email(identifier, options) {
  var _await$provider$gener, _provider$generateVer, _provider$maxAge, _provider$secret;

  const {
    url,
    adapter,
    provider,
    callbackUrl,
    theme
  } = options;
  const token = (_await$provider$gener = await ((_provider$generateVer = provider.generateVerificationToken) === null || _provider$generateVer === void 0 ? void 0 : _provider$generateVer.call(provider))) !== null && _await$provider$gener !== void 0 ? _await$provider$gener : (0, _web.randomString)(32);
  const ONE_DAY_IN_SECONDS = 86400;
  const expires = new Date(Date.now() + ((_provider$maxAge = provider.maxAge) !== null && _provider$maxAge !== void 0 ? _provider$maxAge : ONE_DAY_IN_SECONDS) * 1000);
  const params = new URLSearchParams({
    callbackUrl,
    token,
    email: identifier
  });
  const _url = `${url}/callback/${provider.id}?${params}`;
  const secret = (_provider$secret = provider.secret) !== null && _provider$secret !== void 0 ? _provider$secret : options.secret;
  await Promise.all([provider.sendVerificationRequest({
    identifier,
    token,
    expires,
    url: _url,
    provider,
    theme
  }), adapter.createVerificationToken({
    identifier,
    token: await (0, _web.createHash)(`${token}${secret}`),
    expires
  })]);
  return `${url}/verify-request?${new URLSearchParams({
    provider: provider.id,
    type: provider.type
  })}`;
}