import type { CookiesOptions, InternalOptions } from "../../../types";
import type { RequestInternal, ResponseInternal } from "../../..";
import type { Cookie } from "../../cookie";
/**
 * Generates an authorization/request token URL.
 *
 * [OAuth 2](https://www.oauth.com/oauth2-servers/authorization/the-authorization-request/)
 */
export default function getAuthorizationUrl({ options, query, }: {
    options: InternalOptions<"oauth">;
    query: RequestInternal["query"];
}): Promise<ResponseInternal>;
/** Returns a signed cookie. */
export declare function signCookie(type: keyof CookiesOptions, value: string, maxAge: number, options: InternalOptions<"oauth">): Promise<Cookie>;
