"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getBody = getBody;
exports.setCookie = setCookie;

function setCookie(res, value) {
  var _res$getHeader;

  let setCookieHeader = (_res$getHeader = res.getHeader("Set-Cookie")) !== null && _res$getHeader !== void 0 ? _res$getHeader : [];

  if (!Array.isArray(setCookieHeader)) {
    setCookieHeader = [setCookieHeader];
  }

  setCookieHeader.push(value);
  res.setHeader("Set-Cookie", setCookieHeader);
}

function getBody(req) {
  var _req$headers;

  if (!("body" in req) || !req.body || req.method !== "POST") {
    return;
  }

  const contentType = (_req$headers = req.headers) === null || _req$headers === void 0 ? void 0 : _req$headers["content-type"];

  if (contentType !== null && contentType !== void 0 && contentType.includes("application/json")) {
    return {
      body: JSON.stringify(req.body)
    };
  } else if (contentType !== null && contentType !== void 0 && contentType.includes("application/x-www-form-urlencoded")) {
    return {
      body: new URLSearchParams(req.body)
    };
  }
}