"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {};
exports.default = void 0;

var _core = require("../core");

var _detectHost = require("../utils/detect-host");

var _types = require("../core/types");

Object.keys(_types).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _types[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _types[key];
    }
  });
});

async function WebAuthHandler(req, options) {
  var _options$secret, _options$jwt$secret, _options$jwt, _req$url;

  (_options$secret = options.secret) !== null && _options$secret !== void 0 ? _options$secret : options.secret = (_options$jwt$secret = (_options$jwt = options.jwt) === null || _options$jwt === void 0 ? void 0 : _options$jwt.secret) !== null && _options$jwt$secret !== void 0 ? _options$jwt$secret : process.env.NEXTAUTH_SECRET;
  const host = (0, _detectHost.detectHost)(req.headers["x-forwarded-host"]);
  const url = new URL((_req$url = req.url) !== null && _req$url !== void 0 ? _req$url : "", host);
  const res = await (0, _core.AuthHandler)(new Request(url, req), options);
  const redirect = res.headers.get("Location");

  if (req.headers.get("X-Auth-Return-Redirect") && redirect) {
    res.headers.delete("Location");
    return new Response(JSON.stringify({
      url: redirect
    }), res);
  }

  return res;
}

function Auth(...args) {
  if (!args.length || args[0] instanceof Request) {
    return WebAuthHandler(...args);
  }

  if (args.length === 1) return async req => await WebAuthHandler(req, args[0]);
  return WebAuthHandler(args[0], args[1]);
}

var _default = Auth;
exports.default = _default;